#include "funcref.ch"

Function Main
  Load Window Main
  Main.Center
  Main.Activate
Return

*- 
FUNCTION Main_List_File_OnChange()
  LOCAL cPathFile
  cPathFile := GetListFileSelected()
  UpdateEditFile( cPathFile)
  *- UpdateEditUDF( cPathFile)
  aUDFs  := UpdateGridUDF( cPathFile)
  *- aFuncs := UpdateEditFunc( cPathFile)
  aFuncs := UpdateGridFunc( cPathFile)
  RETURN( { aUDFs, aFuncs})

*-
FUNCTION Main_Button_GetFile_Action()
  cFile := GetFile( {{ "HBP", "*.HBP"}, { "PRG", "*.PRG"}, { "HB", "*.HB"}, { "HTM", "*.HTM"}}, "Text", "\TH\KUDA\", .F., .T.)
  *- cPath := GetPath( cFile)
  MainSetProperty( ZTEXT_PATH, "Value", cFile)
  IF "HBP" $ UPPER( cFile)
    aItems := {}
    cMemoRead := ReadFile( cFile) && HB_MEMOREAD( cFile)
    aItems := HB_ATOKENS( cMemoRead, HB_EOL())
  ELSE
    cPath := GetPath( cFile)
    cFile := STRTRAN( cFile, cPath, '')
    aItems := { cFile}  
  ENDIF
  UpdateListbox( ZFORM_MAIN, ZLIST_FILES, aItems)
  MainSetProperty( ZLIST_FILES, "Value", 1)
  RETURN NIL

FUNCTION Main_Button_hbRegexAll_Action()
  LOCAL eRegex, eFunc
  LOCAL cRegExStr
  cRegExStr := MainGetProperty( ZTEXT_REGEX, "Value")
  aFuncs    := aGetRegexResult( cRegExStr, 3, "hb_RegexAll()")
  *- aFuncs := ASORT( aFuncs, , , {|x, y| x[ 1] < y[ 1]})
  *- cResult   := AToS( aFuncs)
  cResult := PrintArray( aFuncs)
  MainSetProperty( ZEDIT_REGEX, "Value", cResult)
  RETURN NIL
  
FUNCTION Main_Button_hbRegex_Action()
  LOCAL eRegex, eFunc
  LOCAL cRegExStr
  cRegExStr := MainGetProperty( ZTEXT_REGEX, "Value")
  aFuncs    := aGetRegexResult( cRegExStr, 3, "hb_Regex()")
  *- aFuncs := ASORT( aFuncs, , , {|x, y| x[ 1] < y[ 1]})
  *- cResult   := AToS( aFuncs)
  cResult := PrintArray( aFuncs)
  MainSetProperty( ZEDIT_REGEX, "Value", cResult)
  RETURN NIL
  

FUNCTION Main_ProjectUDF_Action()  
  LOCAL cString, cString1, cPjtUDF, cPjtFunc
  LOCAL eFunc
  LOCAL nItemCount, nI
  chbmk2 := ReadFile( "hbmk2find.txt")
  chbmk2 := STRTRAN( chbmk2, ZLF, HB_EOL())
  MainSetProperty( ZEDIT_HBFUNC, "Value", chbmk2)
  *-
  nItemCount := MainGetProperty( ZLIST_FILES, "ItemCount")
  aPjtUDF := {}
  aPjtFunc := {}
  FOR nI := 1 TO nItemCount
    MainSetProperty( ZLIST_FILES, "Value", nI)
    aUDFs := GetGridItems( ZFORM_MAIN, ZGRID_UDF)
    AEVAL( aUDFs, {|x| AADD( aPjtUDF, x)})
    *-
    aFuncs := GetGridItems( ZFORM_MAIN, ZGRID_FUNC)
    FOR EACH eFunc IN aFuncs
      cFunc := eFunc[ 1]
      nFound := ASCAN( aPjtFunc, {|x| UPPER( x[ 1]) == UPPER( cFunc)})
      IF nFound == 0
        eFunc[ 2] := VAL( eFunc[ 2])
        AADD( aPjtFunc, eFunc)
      ELSE
        aPjtFunc[ nFound, 2] := aPjtFunc[ nFound, 2] + VAL( eFunc[ 2])
      ENDIF
    NEXT
    *- cString1 := MainGetProperty( ZEDIT_FUNC, "Value") 
    *- cPjtFunc := AddUnique( cPjtFunc, cString1)
  NEXT
  *- cPjtUDF := ic_SortStr( cPjtUDF)
  WaitWindow( "sorting...UDF", .t.)
  aPjtUDF := ASORT( aPjtUDF, , , {|x, y| x[ 1] < y[ 1]})
  *- MainSetProperty( ZEDIT_PJT_UDF, "Value", cPjtUDF)
  UpdateGrid( ZFORM_MAIN, ZGRID_PJT_UDF, aPjtUDF)
  *- cPjtFunc := ic_SortStr( cPjtFunc)
  *- cPjtFunc := ic_Exclude( cPjtFunc, aPjtUDF)
  *- cPjtFunc := ic_Exclude( cPjtFunc, chbmk2)
  *- MainSetProperty( ZEDIT_PJT_FUNC, "Value", cPjtFunc)
  *- aPjtFunc := ic_Exclude( aPjtFunc, aPjtUDF)
  WaitWindow( "sorting...Func", .t.)
  aPjtFunc := ASORT( aPjtFunc, , , {|x, y| x[ 1] < y[ 1]})
  AEVAL( aPjtFunc, {|x| x[2] := ALLTRIM( STR( x[2]))})
  UpdateGrid( ZFORM_MAIN, ZGRID_PJT_FUNC, aPjtFunc)
  UpdateCalled( ZGRID_PJT_UDF, ZGRID_PJT_FUNC)
  WaitWindow()
  RETURN NIL
*-
FUNCTION Main_Text_File_OnEnter()
  RETURN NIL
  
FUNCTION Main_Grid_UDF_OnChange()  
  nValue := MainGetProperty( ZGRID_UDF, "Value")
  msgDebug( "Grid on", nValue)
  RETURN NIL
*-
FUNCTION Main_OnInit()
  Form_Center( ZFORM_MAIN, "MAX")
  MainSetProperty( "EDIT_1", "Enabled", .F.)
  MainSetProperty( ZEDIT_UDF, "Enabled", .F.) 
  MainSetProperty( ZEDIT_FUNC, "Enabled", .F.) 
  MainSetProperty( ZEDIT_PJT_UDF, "Enabled", .F.) 
  MainSetProperty( ZEDIT_PJT_FUNC, "Enabled", .F.) 
  ArrangeAllCtrl( ZFORM_MAIN)
  MainSetProperty( ZTEXT_REGEX, "Value", ZREGEX_FUNC)
  Main_Button_GetFile_Action()
  RETURN NIL
  
