#include "funcref.ch"

FUNCTION ic_Exclude( cString, cExclude)
  LOCAL aString
  LOCAL eString
  aString := IIF( VALTYPE( cString) == 'C', HB_ATOKENS( cString, HB_EOL()), cString)
  aExclude := IIF( VALTYPE( cExclude) == 'C', HB_ATOKENS( cExclude, HB_EOL()), cExclude)
  *-
  aInclude := {}
  FOR EACH eString IN aString
    IF ASCAN( aExclude, {|x| UPPER( eString[ 1]) # UPPER( x[ 1])}) == 0
      AADD( aInclude, eString)
    ELSE
          
    ENDIF
  NEXT
  RETURN( aInclude)
  
FUNCTION ic_SortStr( cString)
  LOCAL aString
  aString := HB_ATOKENS( cString, HB_EOL())
  aString := ASORT( aString)
  cString := AToS( aString)
  RETURN( cString)
  
FUNCTION AddUnique( cPjtFunc, cString)
  LOCAL eString
  IF EMPTY( cPjtFunc)
    cPjtFunc := cString
  ELSE  
    aString := HB_ATOKENS( cString, HB_EOL())
    FOR EACH eString IN aString
      IF AT( eString, cPjtFunc) == 0 .AND. .NOT. EMPTY( eString)
        cPjtFunc += eString + HB_EOL()
      ENDIF
    NEXT
  ENDIF
  RETURN( cPjtFunc)

FUNCTION ic_RegexAll( cRegExStr, cString, cMode)
  LOCAL aRegex
  LOCAL cRegEx
  aRegex := {}
  cRegEx := hb_RegexComp( cRegExStr)
  IF hb_IsRegex( cRegEx)
    lCase := .F.
    lNewLine := .T.
    IF cMode == "hb_Regex()"
      aRegex := hb_regexAll( cRegEx, cString, lCase, lNewLine,,, .F. )
    ELSE
      aRegex := hb_regexAll( cRegEx, cString, lCase, lNewLine,,, .F. )
    ENDIF  
  ELSE
    msgDebug( "Incorrect RegEx !", cRegExStr, cRegEx)  
  ENDIF
  RETURN( aRegex)

*---
  
FUNCTION aGetUDF( nIndex)
  HB_DEFAULT( @nIndex, 1)
  aRegexResult := aGetRegexResult( ZREGEX_UDF, nIndex)
  aRegexResult := ASORT( aRegexResult, , , {|x, y| x[ 1] < y[ 1]})
  RETURN( aRegexResult)

FUNCTION aGetFunc()
  LOCAL nI
  aUDF := aGetUDF()
  aRegexResult := aGetRegexResult( ZREGEX_FUNC)
  aRegexResult := ASORT( aRegexResult, , , {|x, y| x[ 1] < y[ 1]})
  *- aFunc := {}
  *- FOR nI := 1 TO LEN( aRegexResult)
  *-   cFunc := UPPER( ZSPACE + aRegexResult[ nI, 1])
  *-   IF ASCAN( aUDF, {|x| cFunc $ UPPER( x)}) == 0
  *-     AADD( aFunc, aRegexResult[ nI])
  *-   ENDIF
  *- NEXT
  RETURN( aRegexResult)
  
FUNCTION ToAscii( cString)
  LOCAL cNString, cChar
  LOCAL nI
  lCheckAscii := MainGetProperty( ZCHECK_ASCII128, "Value")
  IF lCheckAscii
    cNString := cString
  ELSE  
    cNString := ''
    FOR nI := 1 TO LEN( cString)
      cChar := SUBSTR( cString, nI, 1)
      IF ASC( cChar) > 127
        cChar := '~'
      ENDIF
      cNString += cChar
    NEXT
  ENDIF
  RETURN( cNString)  

FUNCTION aGetRegexResult( cRegExStr, nIndex, cMode)
  HB_DEFAULT( @nIndex, 1)
  HB_DEFAULT( @cMode, "FUNC")
  cPathFile := GetListFileSelected()
  cMemoRead := ReadFile( cPathFile)
  cMemoRead := ToAscii( cMemoRead)
  aRegex    := ic_regexAll( cRegExStr, cMemoRead,,,,, .F., cMode )
  aFuncs    := aRegexToArray( aRegex, nIndex, cMemoread) 
  aReturn := IIF( cMode == "FUNC", aFuncs, aRegex)
  RETURN( aReturn)
  
FUNCTION aRegexToArray( aRegex, nIndex, cString)
  LOCAL cSubString
  LOCAL eRegex, eFunc
  HB_DEFAULT( @nIndex, 1)
  lAllowDup := .F.
  aFuncs := {}
  aString := HB_ATOKENS( cString, HB_EOL())
  FOR EACH eRegex IN aRegex
    eFunc := eRegex[ 1] && whole match eRegex[ 2...] is subMatch
    *- FOR EACH eFunc IN eRegex
      cFunc := ALLTRIM( eFunc[ 1])
      cFunc := STRTRAN( cFunc, ZCRLF, '')
      *- cFund := STRTRAN( cFunc, "\r\n", ' ')
      *- cFund := STRTRAN( cFunc, HB_EOL(), ' ')
      cFunc := ALLTRIM( cFunc)
      IF EMPTY( cFunc)
        LOOP
      ENDIF
      nStart := eFunc[ 2]
      nEnd   := eFunc[ 3]
      nFound := ASCAN( aString, { |x| cFunc $ x})
      IF nFound == 0
        *- msgDebug( "koq ga ada : ", cFunc, eFunc)
      ELSE
        cFound := ALLTRIM( aString[ nFound])
        IF cFound <> cFunc
          *- commented
          LOOP
        ENDIF
        nRow := nFound
        cRow := ALLTRIM( STR( nRow))
        cEnd := ALLTRIM( STR( nEnd))
        nFound := ASCAN( aFuncs, {|x| x[ 1] == cFunc})
        IF nFound == 0 .OR. lAllowDup
          AADD( aFuncs, { cFunc, cRow, cEnd, 1})  
        ELSE
          aFuncs[ nFound, 4] += 1      
        ENDIF
      ENDIF
      *- EXIT 
    *- NEXT  
  NEXT
  *- aTmp := {}
  *- DO CASE
  *-   CASE nIndex == 1
  *-     AEVAL( aFuncs, {|x| AADD( aTmp, x[ 1])})
  *-   CASE nIndex == 2
  *-     AEVAL( aFuncs, {|x| AADD( aTmp, { x[ 1], x[ 2]})})  
  *-   OTHERWISE
  *-     aTmp := ACLONE( aFuncs)    
  *- ENDCASE
  RETURN( aFuncs)
  
FUNCTION Occur( cSearch, cString)
  LOCAL nOccur
  nLenSearch := LEN( cSearch)
  nOccur := 0
  DO WHILE LEN( cString) > 0
    nAt := AT( cSearch, cString)
    IF nAt > 0
      nOccur++
      cString := SUBSTR( cString, nAt + nLenSearch + 1)
    ELSE
      cString := ''    
    ENDIF
  ENDDO
  RETURN( nOccur)
  
FUNCTION T_UnicodeBoxChar( cLine)
  LOCAL aBoxChar
  LOCAL nI
  aBoxChar := {{ LEFT_TOP,     UNILEFT_TOP}, ;
							 { RIGHT_TOP,    UNIRIGHT_TOP}, ;
							 { LEFT_BOTTOM,  UNILEFT_BOTTOM}, ;
							 { RIGHT_BOTTOM, UNIRIGHT_BOTTOM}, ;
							 { VER,          UNIVER}, ;
							 { HOR,          UNIHOR}, ;
							 { CROSS,        UNICROSS}, ;
							 { TIE,          UNITIE}, ;
							 { UTIE,         UNIUTIE}, ;
							 { LEFT_TIE,     UNILEFT_TIE}, ;
							 { RIGHT_TIE,    UNIRIGHT_TIE}}

	FOR nI := 1 TO LEN( aBoxChar)
		cLine := STRTRAN( cLine, aBoxChar[ nI, 1], aBoxChar[ nI, 2])
	NEXT
	
	RETURN( cLine)
