#include "funcref.ch"

FUNCTION MainSetProperty( ...)
  SetProperty( ZFORM_MAIN, ...)
  RETURN NIL
  
FUNCTION MainGetProperty( ...)
  RETURN( GetProperty( ZFORM_MAIN, ...))
  
FUNCTION StringCompare( cStr1, cStr2)
  LOCAL nI
  nLimit := MIN( LEN( cStr1), LEN( cStr2))
  FOR ni := 1 TO nLimit
    cChar1 := SUBSTR( cStr1, nI, 1)
    cChar2 := SUBSTR( cStr2, nI, 1)
    IF cChar1 <> cChar2
      c1 := SUBSTR( cStr1, nI, 30)
      c2 := SUBSTR( cStr2, nI, 30)
      msgDebug( cChar1, cChar2, nI, c1, c2)
    ENDif
  NEXT
  RETURN NIL

FUNCTION UpdateEditFile( cFile)
  LOCAL cMemoRead
  cMemoRead := ReadFile( cFile)
  cMemoRead := ToAscii( cMemoRead)
  cMemoRead := STRTRAN( cMemoread, ZCRLF, ZLF)
  MainSetProperty( ZEDIT_FILE, "Value", cMemoRead)
  cString := MainGetProperty( ZEDIT_FILE, "Value")
  *- cString := STRTRAN( cString, ZCR, ZCRLF)
  IF LEN( cMemoRead) <>  LEN( cString)
    lCheckAscii := MainGetProperty( ZCHECK_ASCII128, "Value")
    msgDebug( lCheckAscii, cFile, "Memoread Len :", LEN( cMemoRead), "Editbox Value Len : ", LEN( cString))
  *-  StringCompare( cMemoread, cString)
  ENDIF
  *- cMemoread80 := right( cMemoread, 80)
  *- cString80 := right( cString, 80)
  *- cString80 := STRTRAN( cString80, ZCR, HB_EOL())
  *- cString80 := RIGHT( cString80, 80)
  *- if cMemoread80 <> cString80
  *-   msgDebug( cFile, len( cMemoread), len( cstring), cMemoread80, cString80, len( cMemoread80), len( cString80))
  *- endif  
  RETURN NIL

FUNCTION UpdateEditUDF( cFile)
  LOCAL aUDFs
  LOCAL cResult
  aUDFs  := aGetUDF()
  cResult := AToS( aUDFs)
  MainSetProperty( ZEDIT_UDF, "Value", cResult)
  RETURN NIL
  
FUNCTION GetGridItems( cFormname, cGridname)
  LOCAL aItems
  LOCAL nI
  nItemCount := GetProperty( cFormname, cGridname, "ItemCount")
  aItems := {}
  FOR nI := 1 TO nItemCount
    AADD( aItems, GetProperty( cFormname, cGridname, "Item", nI))
  NEXT
  RETURN( aItems)
  
*- FUNCTION UpdateEditFunc( cFile)
*-   LOCAL aUDFs
*-   LOCAL cResult
*-   LOCAL nI
*-   aGetFuncs  := aGetFunc()
*-   cResult := AToS( aFuncs)
*-   MainSetProperty( ZEDIT_FUNC, "Value", cResult)
*-   RETURN( aFuncs)

FUNCTION UpdateGridUDF( cFile)
  LOCAL aUDFs
  LOCAL eUDF
  LOCAL cResult
  aUDF1  := aGetUDF( 2)
  aUDFs := {}
  IF .NOT. EMPTY( aUDF1)
    FOR EACH eUDF IN aUDF1
      AADD( aUDFs, { eUDF[ 1], '0', eUDF[ 2]})
    NEXT
  ENDIF
  UpdateGrid( ZFORM_MAIN, ZGRID_UDF, aUDFs)
  RETURN( aUDFs)

FUNCTION UpdateGridFunc( cFile)
  LOCAL aFuncs
  LOCAL eFunc
  LOCAL cResult
  aGetFuncs  := aGetFunc( 2)
  aGridUDFs := GetGridItems( ZFORM_MAIN, ZGRID_UDF)
  aFuncs := {}
  IF .NOT. EMPTY( aGetFuncs)
    FOR EACH eFunc IN aGetFuncs
      AADD( aFuncs, { eFunc[ 1], ALLTRIM( STR( eFunc[ 4])), '0'})
    NEXT  
    
    *-   *- update UDF grid
    *-   cFunc := eFunc[ 1]
    *-   nCalled := eFunc[ 4]
    *-   nFound := ASCAN( aGridUDFs, {|x| UPPER( cFunc) $ UPPER( x[ 1])})
    *-   IF nFound > 0
    *-     aGridUDFs[ nFound, 2] := ALLTRIM( STR( nCalled))
    *-     *- MainSetProperty( ZGRID_UDF, "Cell", nFound, 2, nCalled)
    *-     MainSetProperty( ZGRID_UDF, "Item", nFound, aGridUDFs[ nFound])
    *-   ENDIF
    *- NEXT
  ENDIF
  UpdateGrid( ZFORM_MAIN, ZGRID_FUNC, aFuncs)
  UpdateCalled( ZGRID_UDF, ZGRID_FUNC)
  RETURN( aFuncs)
  
FUNCTION UpdateCalled( cGridUdf, cGridFunc)
  LOCAL aGridUDFs, aGridFuncs
  LOCAL eFunc
  LOCAL cFunc
  LOCAL nCalled, nFound
  aGridUDFs  := GetGridItems( ZFORM_MAIN, cGridUDF)  
  aGridFuncs := GetGridItems( ZFORM_MAIN, cGridFunc)
  FOR EACH eFunc IN aGridFuncs
    cFunc := eFunc[ 1]
    nCalled := eFunc[ 2]
    nFound := ASCAN( aGridUDFs, {|x| UPPER( cFunc) $ UPPER( x[ 1])})
    IF nFound > 0
      aGridUDFs[ nFound, 2] := nCalled
      *- MainSetProperty( ZGRID_UDF, "Cell", nFound, 2, nCalled)
      MainSetProperty( cGridUDF, "Item", nFound, aGridUDFs[ nFound])
    ENDIF  
  NEXT
  RETURN NIL
  
FUNCTION GetPath( cFilename)
  nRBSlash := RAT( ZBSLASH, cFilename)
  cPath := ''
  IF nRBSlash > 0
    cPath := LEFT( cFilename, nRBSlash)
  ENDIF
  RETURN( cPath)

FUNCTION UpdateGrid( cFormName, cGridName, aItems)
  LOCAL nI
  DoMethod( cFormName, cGridName, "DeleteAllItems")
  
  FOR nI := 1 TO LEN( aItems)
    IF .NOT. EMPTY( aItems[ nI])
      DoMethod( cFormName, cGridName, "AddItem", aItems[ nI])
    ENDIF
  NEXT
  RETURN NIL
  
FUNCTION UpdateListbox( cFormName, cListName, aItems)
  LOCAL nI
  DoMethod( cFormName, cListName, "DeleteAllItems")
  FOR nI := 1 TO LEN( aItems)
    IF .NOT. EMPTY( aItems[ nI])
      DoMethod( cFormName, cListName, "AddItem", aItems[ nI])
    ENDIF
  NEXT
  RETURN NIL
*-
  
*-
  
FUNCTION GetListFileSelected()
  LOCAL cFile, cPath
  LOCAL nValue
  nValue := MainGetProperty( ZLIST_FILES, "Value")
  cFile  := MainGetProperty( ZLIST_FILES, "Item", nValue)
  cPath  := GetPath( MainGetProperty( ZTEXT_PATH, "Value"))
  IF AT( ZBSLASH, cFile) == 0
    cFile := cPath + cFile
  ENDIF
  RETURN( cFile)  
*-
  *-
FUNCTION AToS( aArray, cSep)
  LOCAL eArray
  HB_DEFAULT( @cSep, HB_EOL())
  cString := ''
  FOR EACH eArray IN aArray
    IF VALTYPE( eArray) == 'A'
      cString += AToS( eArray, ", ") + cSep
    ELSE  
      *- msgDebug( eArray, VALTYPE( eArray))
      cString += xtoc( eArray) + cSep
    ENDIF
  NEXT
  RETURN( cString)

FUNCTION PrintArray( aArray, nTab)
  LOCAL cArray, cString
  LOCAL nI, nLenArray
  HB_DEFAULT( @nTab, 1)
  cTab := SPACE( nTab)
  nLenArray := LEN( aArray)
  cString := cTab + '{ '
  FOR nI := 1 TO nLenArray
    cArray := aArray[ nI]
    IF VALTYPE( cArray) == 'A'
      cString += HB_EOL() + " ."
      cString += PrintArray( cArray, nTab + 1)
    ELSE
      cString += xtoc( cArray) 
      cString += IIF( nI < nLenArray, ', ', '.')
    ENDIF  
  NEXT
  cString += "}"
  RETURN( cString)
  
FUNCTION ReadFile( cFile)
  cMemoRead := ''
  IF .NOT. EMPTY( cFile)
    IF FILE( cFile) 
      cMemoRead := HB_MEMOREAD( cFile)
    ELSE
      MsgDebug( cFile, ZNOTFOUND)
    ENDIF
  ENDIF
  RETURN( cMemoRead)
  
FUNCTION Control_Pos( cFormName, cCtrlName, aColRow)
  nCol := aColRow[ 1]
  nRow := aColRow[ 2]
  SetProperty( cFormName, cCtrlName, "Col", nCol)
  SetProperty( cFormName, cCtrlName, "Row", nRow)
  RETURN NIL  

*-
FUNCTION ArrangeAllCtrl( cFormname)
  LOCAL nI
  nFormWidth  := GetProperty( cFormname, "Width")
  nFormHeight := GetProperty( cFormname, "Height")
  nDR := 10
  nDC := 10
  nJC := 4
  nJR := 4
  nWidth4  := INT( ( nFormWidth - ( nJC + 2) * nDC) / nJC)
  nHeight2 := INT( ( nFormHeight - ( nJR + 4) * nDR - ( 2 * 30)) / 2)
  aCtrl := {{ "Button_1", "Text_1", ZCHECK_ASCII128 }, ;
            { "List_1"  , "RichEdit_1"  , ZGRID_UDF  , ZGRID_FUNC}, ;
            { "Text_2"  , ZBUTTON_HB_REGEX_ALL, ZBUTTON_HB_REGEX, ZBUTTON_PROJECTUDF}, ;
            { "Edit_4"  , "Edit_5"  , ZGRID_PJT_UDF  , ZGRID_PJT_FUNC}}
  nRow := 0
  nHeight := 0
  FOR nI := 1 TO LEN( aCtrl) 
    nRow += nDR + nHeight
    nCtrlHeight := MainGetProperty( aCtrl[ nI, 1], "Height")
    nHeight := IIF( MOD( nI, 2) == 0, nHeight2, nCtrlHeight)
    nCol := 0
    nWidth := 0
    FOR nJ := 1 TO LEN( aCtrl[ nI])
      cCtrlName := aCtrl[ nI, nJ]
      nCol += nDC + nWidth
      nCtrlWidth := MainGetProperty( cCtrlName, "Width")
      nWidth := IIF( MOD( nI, 2) == 0, nWidth4, nCtrlWidth)
      IF cCtrlName $ ZGRID_UDF + ZGRID_PJT_UDF + ZGRID_FUNC + ZGRID_PJT_FUNC
        *- MainSetProperty( ZGRID_UDF, "Widths", aWidth)
        MainSetProperty( cCtrlName, "ColumnWidth", 2, 50)
        MainSetProperty( cCtrlName, "ColumnWidth", 3, 50)
        MainSetProperty( cCtrlName, "ColumnWidth", 1, nWidth-100)
      ENDIF
      Ctrl_Resize( ZFORM_MAIN, cCtrlName, nRow, nCol, nWidth, nHeight)
    NEXT
  NEXT
  RETURN NIL

FUNCTION Ctrl_Resize( cFormName, cCtrlName, nRow, nCol, nWidth, nHeight)  
  SetProperty( cFormName, cCtrlName, "Row  ", nRow    )
  SetProperty( cFormName, cCtrlName, "Col  ", nCol    )
  SetProperty( cFormName, cCtrlName, "Width", nWidth  )
  SetProperty( cFormName, cCtrlName, "Height", nHeight )
  RETURN NIL
  
FUNCTION Form_Center( cFormName, cSize)
  nDesktop_Width  := GetDesktopWidth()
  nDesktop_Height := GetDesktopHeight()
  IF cSize == "MAX"
    nRatio := 1
    nTaskBarHeight := 50
    nDesktop_Height -= nTaskbarHeight
  ELSE
    nRatio := 2
    nTaskBarRow := 0
  ENDIF
  nForm_Width  := nDesktop_Width  / nRatio
  nForm_Height := ( nDesktop_Height - 50) / nRatio 
  nForm_Col := ( nDesktop_Width  - nForm_Width)  / 2
  nForm_Row := ( nDesktop_Height - nForm_Height) / 2
  *- nTaskbarRow := 50
  SetProperty( cFormName, "Col", nForm_Col)
  SetProperty( cFormName, "Row", nForm_Row)
  SetProperty( cFormName, "Width",  nForm_Width)
  SetProperty( cFormName, "Height", nForm_Height)
  RETURN( { nForm_Width, nForm_Height})
  
*---
FUNCTION xToC ( x )
  LOCAL c
	DO CASE
		CASE ValType ( x ) == 'C'
			c := x
  		if empty(c)
        c := '"' + c + '"'
			endif
		CASE ValType ( x ) == 'N'
			c := Str(x)
		CASE ValType ( x ) == 'D'
			c := dToC (x)
		CASE ValType ( x ) == 'L'
			c := if ( x , '.T.' , '.F.' )
		CASE ValType ( x ) == 'U'
			c := 'Nil'
	ENDCASE
	Return c

  